namespace java com.example.myapp.user
namespace php MyApp.User
namespace js MyApp.User

/** 言語: 日本語 */
const string LANGUAGE_JA = "JA";
/** 言語: 英語 */
const string LANGUAGE_EN = "EN";

/** ユーザ情報 */
struct User {
  1: required i64 id,
  2: required string name,
  3: optional string language,
  4: optional string iconUrl,
}

/**
 * ユーザ情報取得のためのオプショナルな項目
 */
struct UserOption {
  /** 言語を取得するか */
  1: optional bool withLanguage = false,
  /** 取得するアイコン */
  2: optional bool withIcon = false,
}

service UserService
{
  /** ユーザIDをもとにユーザ一覧を取得 */
  list<User> findByIds(
    1: list<i64> ids, 2: UserOption opt,
  ),
}
